/*
*
*
*   Author: Christian Sarmoria   Base code from CPS616 course.
*
*   Date:   02-18-99
*
*   Course: CPS - 616 Project #1
*
*   File name: myDatabase.java
*
*
*
*    Used from file Client.java
*    Errors and informational messages can be viewed on the Java Console.
*/


/* myDatabase.java
 * This class provides methods to access the Oracle database via JDBC
 * API:void open()
 *     void find(String word, Stringbuffer s1, Stringbuffer s2, Stringbuffer s3)
 *     void close ()
 *     void move(String word, StringBuffer s1, StringBuffer s2, StringBuffer s3, StringBuffer s4, StringBuffer s5, StringBuffer s6)
 *     void addrecord(String d1, String d2, String d3, String d4, String d5)
 *     void deleterecord(String d1)
 * Exceptions are printed.
 */


import java.sql.*;
import java.util.Properties;

// the database main class
class myDatabase {

  public ResultSet rs;
  private Connection conn;

  public void open() {
    try {
      Class.forName("oracle.jdbc.driver.OracleDriver");

      System.out.println("After Class.forName is OK");
      conn = DriverManager.getConnection("jdbc:oracle:thin:@carver.npac.syr.edu:1521:europe","cy99cps","cy99cps");

      System.out.println("Connection Open");
    }
    catch (Exception e) { System.err.println("Error connection in Open  from class myDatabase: " + e);}
  }


  // query to search according to string entered by user
  public void find(String word, StringBuffer s1, StringBuffer s2, StringBuffer s3, StringBuffer s4, StringBuffer s5, StringBuffer s6) {

    try {
      word = word + "%";
      System.out.println("name passed = " + word);
      // binding input parameters to SQL call
      PreparedStatement pstmt = conn.prepareStatement("select * from planes, equipment where NAME like ? and planes.code = equipment.code_equ");
      pstmt.setString(1,word);
     // Execute the SQL, ResultSet is row(s) of data returned by database query
//      ResultSet rs = pstmt.executeQuery();
      rs = pstmt.executeQuery();
      // return the fields of the first row of the result set
      rs.next();
      s1.append(rs.getString("CODE"));
      s2.append(rs.getString("NAME"));
      s3.append(rs.getString("MADEIN"));
      s4.append(rs.getString("PICTURE"));
      s5.append(rs.getString("BASEPRICE"));
      s6.append(rs.getString("DAYS_TO_BUILD"));

      // closing statement
      pstmt.close();
    }
    catch (Exception e) {
      System.err.println("Error in dbase when doing Find in myDatabaase  class");
      e.printStackTrace();
    }
  }

  // to move to next record when query returns multiple instances
  public void move(String word, StringBuffer s1, StringBuffer s2, StringBuffer s3, StringBuffer s4, StringBuffer s5, StringBuffer s6) {

    try {
      rs.next();
      s1.append(rs.getString("CODE"));
      s2.append(rs.getString("NAME"));
      s3.append(rs.getString("RELEASED"));
      s4.append(rs.getString("MADEIN"));
      s5.append(rs.getString("PICTURE"));
      s6.append(rs.getString("BASEPRICE"));
    }
    catch (Exception e) {
      System.err.println("Error in dbase");
      e.printStackTrace();
    }
  }


  // Add record to database
  public void addrecord(String d1, String d2, String d3, String d4, String d5) {

    try {
      System.out.println("Add Record name passed = " + d1);
      // binding input parameters to SQL call
      PreparedStatement pstmt = conn.prepareStatement(" insert into countries (name, capital, population, continent, secure) values ('" + d1 + "', '" + d2 + "', " + d3 + ", '" + d4 + "', '" + d5 + "')");
      rs = pstmt.executeQuery();
      // closing statement
      pstmt.close();
    }
    catch (Exception e) {
      System.err.println("Error in dbase");
      e.printStackTrace();
    }
  }


  // deletes record from database
  public void deleterecord(String d1) {

    try {
      System.out.println("name passed = " + d1);
      // binding input parameters to SQL call
      PreparedStatement pstmt = conn.prepareStatement(" delete from countries where name = '" + d1 + "'");
      rs = pstmt.executeQuery();
      pstmt.close();
    }
    catch (Exception e) {
      System.err.println("Error in dbase");
      e.printStackTrace();
    }
  }



  // closes connection with Oracle server.
  public void close() {
    try {
      conn.close();
      System.out.println("Connection Closed");
    }
    catch (Exception e) {System.err.println("Error in closing dbase");}
  }
}


